# -*- coding: utf-8 -*-
'''
Создает и показывает диалог параметров питания
(c)2012 ЗАО "РИПАС" и Демин Федор,
www.ripas.ru dff@ripas.ru
'''

class PowerControlDialog():
	def __init__(self, obj, mainWindow):
		from PythonQt import QtCore, QtGui
		doc = QtGui.QDockWidget(u'%i(%s):контроль питания'%(obj.id, obj.description), None)
		doc.setAttribute(QtCore.Qt.WA_DeleteOnClose)
		ed = QtGui.QPlainTextEdit(u'Ожидание ответа от устройства...', doc)
		ed.readOnly = True
		doc.setWidget(ed)
		mainWindow.addDockWidget(QtCore.Qt.TopDockWidgetArea, doc)

		resp=obj.sendCommand('get_power')
		resp.connect('finished()', self.responseFinished)

		self.response = resp
		self.ed = ed

	def responseFinished(self):
		ed = self.ed
		resp = self.response
		ed.clear()
		if resp.error:
			ed.appendPlainText(resp.errorString(True))
			return

		#ed.appendPlainText(resp.toString())
		data = resp.data
		fl = data[0]

		if fl & 1:
			s = u'UPS присутствует'
			if fl & 2: s = s + u', неисправен'
			else: s = s + u', исправен'
			if fl & 4: s = s + u', батарея неисправна'
			else: s = s + u', батарея исправна'
			if fl & 8: s = s + u', работа от АКБ'
			else: s = s + u', работа от сети'
			if fl & 16: s = s + u', батарея разряжена'
			else: s = s + u', батарея заряжена'
			ed.appendPlainText(s)
			s=u'Заряд АКБ '
			charge=data[1]
			if charge > 100: s = s + u'неизвестен'
			else: s += str(charge) + '%'
			ed.appendPlainText(s)
			#ed.appendPlainText(u'Заряд АКБ %u%%'%data[1])
			ed.appendPlainText(u'Напряжение первичной сети от UPS %uВ'%data[2])
			if fl & 8: ed.appendPlainText(u'Текущее время работы от АКБ %u минут'%data[3])
		else:
			ed.appendPlainText(u'UPS отсутствует')

		if fl & 0x80:
			ed.appendPlainText(u'\nЭлектросчетчик присутствует')
			ed.appendPlainText(u'Текущее значение потребляемой мощности %u Вт'%data[4])
			ed.appendPlainText(u'Максимальное значение потребляемой мощности за время работы ДК %u Вт'%data[5])
			for i in range(6, len(data)):
				ed.appendPlainText(u'Показания по тарифу %u: %s'%(i-5, data[i]))
		else:
			ed.appendPlainText(u'\nЭлектросчетчик отсутствует')

