# -*- coding: utf-8 -*-
"""
Панель инструментов 'Предустановленные виды':

(c)2012 ЗАО "РИПАС" и Демин Федор,
www.ripas.ru dff@ripas.ru
"""
from gui import mainWindow
from PythonQt.QtGui import QToolBar
from PythonQt.Qt import QActionGroup
presetsGroup={}

def createPreset(preset):
    tb=mainWindow.findChild(QToolBar, 'toolBarPreset')
    if tb: tb.clear()
    else:
        tb=mainWindow.addToolBar(u'Предустановленные виды')
        tb.objectName='toolBarPreset'
    agr = QActionGroup(tb)
    for p in preset:
        a=agr.addAction(p[0])
        a.setData(p[1])
        a.toolTip=p[2]
        presetsGroup[a.text]=a
        if len(p) > 3:
            from RoadCentre import project
            from PythonQt.QtGui import QIcon
            a.icon = QIcon(project.baseDir + '/' + p[3])

    tb.addActions(agr.actions())
    agr.connect('triggered(QAction*)', actionPreset)

def loadPreset(settings):
    presetsGroup={}
    keys=frozenset(('lat', 'lon', 'name', 'zoom')) #, 'toolTip'
    preset=[]
    for i in range(settings.beginReadArray('Presets')):
        settings.setArrayIndex(i)
        if not keys.issubset(settings.childKeys()): continue #Все обязательные поля должны быть определены
        p = settings.value('name'), \
            list(map(float, (settings.value('lon'), settings.value('lat'), settings.value('zoom')))), \
            settings.value('toolTip')
        if settings.contains('icon'): p += (settings.value('icon'),)
        preset.append(p)
    settings.endArray()
    createPreset(preset)

def clearPresets():
    tb=mainWindow.findChild(QToolBar, 'toolBarPreset')
    if tb: tb.clear()

def actionPreset(act):
    from gui import osmView as graphicsView
    a = act.data()
    graphicsView.loadPreset(a[0], a[1], a[2])

def activatePreset(name):
    if name in presetsGroup:
        actionPreset(presetsGroup[name])
