# -*- coding: utf-8 -*-
"""
Модуль Spectr

(c)2013 ЗАО "РИПАС" и Демин Федор,
www.ripas.ru dff@ripas.ru
"""

import RoadCentre


if hasattr(RoadCentre.plugins,'SpectrPlugin'):

    import spectr.spectr as sp_module
    import spectr.tooltip
    import spectr.keepalive

    sp_module.connectToProject(RoadCentre.project)
    tooltip.connectToProject(RoadCentre.project)
    keepalive.project = RoadCentre.project

def getDeviceVersion(dev):
    t = dev.type
    if t == u'UK_GEAR': return 0x0002ffff
    if t.lower() == u'spectr2': return 0x0003ffff
    if t.lower() == u'мфу': return 0x0004ffff
    if not t[-1].isdigit():
        t=t[:-1]
    if t == u'Спектр V3.15': ver = 315
    elif t == u'Спектр V3.16': ver = 316
    elif t == u'Спектр V3.17': ver = 317
    elif t == u'Спектр': ver = 314
    else: ver = 0
    return ver
