# -*- coding: utf-8 -*-
"""
(c)2014 ЗАО "РИПАС" и Демин Федор,
www.ripas.ru dff@ripas.ru
"""
"""
Периодическая повторная отправка команд управления, с целью подтверждения активности
"""

from time import time
from PythonQt.QtCore import QTimer

timeout = 60
objects = {}
timer = QTimer()
commands=dict(
    SET_PROG="obj.currentProgram==param",
    SET_PHASE="obj.currentPhase==param",
    SET_YF="(obj.controlAlgorithm==0 or obj.controlAlgorithm==255) and obj.keyRegime==2",
    SET_OS="obj.controlAlgorithm==255 and obj.keyRegime==0"
    )

def onTimer():
    for obj in list(objects.keys()):
        try:
            if not obj.isConnected: continue
            command, param, t = objects[obj]
            if time() - t < timeout: continue
            if obj.controlSource != 3 or not eval(commands[command]):
                objects.pop(obj)
                continue
            obj.sendCommand(command, param)
            objects[obj][2] = time()
        except:
            objects.pop(obj)

def objectResponseFinished(resp, obj):
    command = str(resp.request.command).upper()
    if (command not in commands) or (resp.error != 0x1200): return
    param = resp.request.param
    objects[obj] = [command, param, time()]

def start(checkperiod = 10000):
    timer.start(checkperiod)

def stop():
    timer.stop()

def init(checkperiod = 10000):
    project.connect(
        'objectResponseFinished(const QObject*, const Spectr::Light*)',
        objectResponseFinished
    )
    timer.connect('timeout()', onTimer)
    start(checkperiod)
