# -*- coding: utf-8 -*-
"""
(c)2011-2013 ЗАО "РИПАС" и Демин Федор,
www.ripas.ru dff@ripas.ru
"""
"""
Парсинг протокола "СПЕКТР"
"""

controlAlgorithms = {
	0: u"Желтое мигание",
	1: u"Таймер",
	2: u"Таймер с координацией",
	3: u"Пешеходный",
	4: u"Вызывные фазы",
	5: u"Вызывные фазы с координацией",
	6: u"Алгоритм поиска разрыва потока транспорта",
	7: u"Поворот из накопителя на приоритетном направлении",
	8: u"Последовательность проезда",
	9: u"Алгоритм поиска разрыва потока транспорта с координацией",
	10: u"Два псевдо независимых пешеходных поста",
	11: u"Переключение по контрольным точкам",
	12: u"Алгоритм Вебстера",
	13: u"Контроль по длине очереди",
	14: u"Две вызывные фазы к каждой основной по разным  условиям",
	15: u"Две вызывные фазы к каждой основной по разным  условиям с координацией",
	16: u"Расширенный алгоритм поиска разрыва потока транспорта",
	17: u"Расширенный алгоритм поиска разрыва потока транспорта с координацией",
	18: u"Разъезд по одной полосе (тоннель) с подсчётом ТС",
	19: u"Разъезд по одной полосе (тоннель) с датчиками тоннеля",
	20: u"Пешеходный M",
	21: u"Приоритетный пропуск транспорта",
	22: u"Приоритетный пропуск транспорта с координацией",
	23: u"Поиск разрыва с координацией (разность на последней фазе)",
	24: u"Поиск разрыва с критерием \"рыхлости потока\"",
	25: u"Поиск разрыва с критерием \"рыхлости потока\" и координацией",
	26: u"Поиск разрыва с вызывной фазой",
	40: u"Лента времени",
	41: u"Последовательность фаз",
	42: u"Цикл фаз",
	43: u"Цикл фаз с координацией",
	44: u"Многокольцевой",
	45: u"Многокольцевой с координацией",
	46: u"Многокольцевой с приоритетным пропуском транспорта",
	47: u"Многокольцевой с приоритетным пропуском транспорта и координацией",

	240: u"Стартовый период включения (переход КК-ЖМ-программа)",
	248: u"Плавный переход от одной программы (алгоритма) к другой",
	251: u"МГР в системе АСУДД \"Сигнал\" - устарел",
	252: u"Управление на уровне вызова фаз",
	253: u"Управление на уровне групп",
	254: u"Управление на уровне прямого обращения к ключам",
	255: u"Нет алгоритма используемого в настоящее время - заморозка состояния",
}

controlSources = (
	u"отсутствует - технологический приём существует не более 1сек",
	u"календарная автоматика",
	u"контролер 2 уровня (в настоящее время не существует)",
	u"АСУДД",
	u"ВПУ",
	u"инженерный пульт",
	u"клавиатура передней панели контроллера",
	u"обработчик ошибок - соответствует аварийному ОС или ЖМ",
)
keyRegimes = (
	u"ОС",
	u"управление ключами",
	u"ЖМ",
	u"управление группами",
)
damages = (
	u"неисправна внутренняя шина SPI",
	u"неисправна внутренняя шина TWI",
	u"неисправна /отсутствует конфигурационная микросхема памяти",
	u"неверна контрольная сумма конфигурационного файла",
	u"некорректность конфигурационного файла", # - обнаруживается во время исполнения (например, ссылка на несуществующие данные",
	u"неисправен контроллер внутренней сети",
	u"несоответствие устройств сети их описанию в конфигурации",
	u"неисправность любого из устройств внутренней сети",
	u"авария по конфликту зелёного",
	u"вторичные напряжения питания вне допуска",
	u"перегрузка по общему потребляемому току уровень 2 (два номинала)",
	u"силовой выключатель базового блока не включается",
	u"силовой выключатель блока расширения не включается",
	u"авария по контролю красного",
	u"перегрузка по общему потребляемому току уровень 1 (номинал)",
	u"5сек ЖМ перед применением команды Reset"
)
errors = (
	u"ошибка микросхемы часов",
	u"недостоверность времени",
	u"недостоверность даты",
	u"неисправность подсистема журнала",
	u"нагрузки силовых ключей вне допуска", # (зарегистрировано изменение нагрузки хотя бы на одном ключе, как правило, вызванное сгоранием ламп)",
	u"неисправность хотя бы одного ключа",
	u"короткое замыкание в нагрузке",
	u"межкабельное замыкание", #(появление на нагрузке непрогнозируемого напряжения при исправном, выключенном ключе)",
	u"силовой выключатель базового блока не выключается",
	u"силовой выключатель блока расширения не выключается",
	u"в составе сети присутствуют устройства с устаревшими версиями ограничивающие функциональность ДКСФ",
	u"недостаточный размер МС конфигурации для обновления ПО"
)
units = (
	u"устройство синхронизации (приёмник)",
	u"адаптер АСУДД",
	u"устройство сопряжения с табло",
	#u"устройство сопряжения с подсистемой приоритетного пропуска транспорта",
	u"устройство ВПУ",	# заменено в версии 3.16
	u"модуль детекторов №1",
	u"модуль детекторов №2",
	u"модуль детекторов №3",
	u"модуль детекторов №4",
	u"адаптер электросчётчика",
	u"адаптер блока бесперебойного электропитания",
	u"адаптер устройства приоритетного пропуска транспорта"
)
powers = (
	u"вторичный источник +30В вне допуска",
	u"вторичный источник +5В вне допуска",
	u"температура вне допуска",
	u"батарея часов разряжена или неисправна (отсутствует)",
	u"первичное питание (220В 50Гц) присутствует",
	u"тумблер передней панели разрешает включение питания",
	u"силовой выключатель включен",
	u"силовое питание реально включено"
)
ecuStatus = (
	u"РУ",
	u"ЖМ",
	u"ОС",
	u"крышка открыта",
)

def controlAlgorithmName(n):
	if n in controlAlgorithms: return controlAlgorithms[n]
	else: return u"неизвестен"

def papamToStr(param, n):
	if n < len(param): return param[n]
	else: return u"неизвестный тип"

def flagsToStr(title, fl, param):
	ret = u"<li><b>%s:</b>" % title
	if(fl == -1): ret += u'неизвестно'
	elif fl:
		ret += '<ul>'
		n = 0
		while fl:
			if fl & 1: ret += '<li>' + papamToStr(param, n)
			n+=1; fl>>=1
		ret += '</ul>'
	else: ret += u" нет"
	return ret

