# -*- coding: utf-8 -*-
"""
(c)2011-2013 ЗАО "РИПАС" и Демин Федор,
www.ripas.ru dff@ripas.ru
"""
"""
Обновляет tooltip объекта контроллера "СПЕКТР"
Для использования нужно функцию update подключить к сигналу objectStateChanged проекта:
project.connect('objectStateChanged(const QObject*)', tooltip.update)
"""

from spectr.parse import *
from PythonQt import QtCore

def update(obj):
    toolTip = \
        '<style>LI{text-indent:10px}UL{margin-top:0;margin-bottom:0}</style>' \
        '<nobr>' \
        u'Контроллер: <b>%u - %s</b><br>' \
        u'Тип: <b>%s</b><hr>' '</nobr>' \
        %(obj.id, obj.description, obj.type);

    if obj.isConnected:
        obj_type=obj.type.lower()
        if obj.testModeFlag == 1 and not obj_type.startswith('адаптер') and not obj_type.startswith('кду'):
            toolTip += u'<font color="#ff0000"><center><b>Тестовый режим</b></center></font><hr>'
        prg = obj.currentProgram

        if 50 <= prg <= 53: s = u'(измененный оператором режим)'
        elif 54 <= prg <= 57: s = u'(расписание)'
        else: s = ''
        toolTip += \
            u'Подключен: <b>%s</b><br>' \
            u'Источник управления: <b>%s %s</b><br>' \
            %(
                obj.connectionTime.toString(QtCore.Qt.DefaultLocaleShortDate),
                papamToStr(controlSources, obj.controlSource),
                s
            )

        #ВПУ "Статус ключа: "

        if prg == 255: s = u"отсутствует"
        elif prg < 0: s = u"неизвестная"
        else:
            s = "%u - " % prg
            if 50 <= prg <= 57: s += u"динамическая"
            else:
                for p in obj.programs():
                    if p.id == prg:
                         s += p.description
                         break
                else: s += u'<font color="#808000">нет в базе!</font>'
        toolTip += \
            u'Алгоритм управления: <b>%s</b><br>' \
            u'Режим: <b>%s</b><br>' \
            u'Программа: <b>%s</b><br>' \
            u'Расхождение с системным временем: <b>%u сек</b>' \
            %(
                controlAlgorithmName(obj.controlAlgorithm),
                papamToStr(keyRegimes, obj.keyRegime),
                s, obj.differenceSysTime
            )

        if obj.lastStatusTime.isValid():
            toolTip += u"<hr>Статус от <b>" + obj.lastStatusTime.toString(QtCore.Qt.DefaultLocaleShortDate) + "</b> :" + \
                    flagsToStr(u"Аварии", obj.damageFlags, damages) + \
                    flagsToStr(u"Ошибки", obj.errorFlags&0xfbff, errors)
            u = obj.unitFlags; g = obj.unitGoodFlags
            toolTip += flagsToStr(u"Устройства исправные", u&g, units)
            if u != -1: toolTip += flagsToStr(u"Устройства неисправные", u&g^u, units)
            toolTip += flagsToStr(u"Флаги питания", obj.powerFlags, powers)

        if obj.ecuStatus >= 0:
            toolTip += u"<hr>Состояние ВПУ: <b>"
            if obj.ecuLock: toolTip += u"заблокировано</b>"
            else: toolTip += u"разблокировано</b>"
            toolTip += flagsToStr(u"Флаги состояния", obj.ecuStatus, ecuStatus)

    else:
        if obj.lastConnectionEventTime.isValid():
            s = obj.lastConnectionEventTime.toString(QtCore.Qt.DefaultLocaleShortDate)
        else:
            s = u"на связи не был"
        toolTip += u"Отключен" u"<br>Последний раз был на связи: <b>%s</b>" % s

    toolTip += \
        u"<nobr><hr>Статистика от <b>%s</b> :<br>" \
        u"Команд отправлено: <b>%u</b>, невыполнено: <b>%u</b>, в очереди: <b>%u</b><br>" \
        u"Сообщений всего: <b>%u</b>, из них об ошибках: <b>%u</b>, об авариях: <b>%u</b><br>" \
        u"Количество отключений: <b>%u</b></nobr>" \
        %(
            obj.statistics.time.toString(QtCore.Qt.DefaultLocaleShortDate),
            obj.statistics.commands, obj.statistics.cmdErrors, obj.statistics.cmdQueue,
            obj.statistics.events, obj.statistics.eventErrors, obj.statistics.eventDamages,
            obj.statistics.disconnection
        )

    obj.toolTip=toolTip


def connectToProject(project):
    project.connect('objectStateChanged(const QObject*)', update)
